-- buff = { "victim", "skill", "amountRank" },
-- cast = { "source", "skill", "victim", "isBegin", "isPerform" },
-- create = { "source", "item" },
-- death = { "victim", "source", "skill", "isItem" },
-- debuff = { "victim", "skill", "amountRank" },
-- dispel = { "victim", "skill", "source", "sourceSkill", "isFailed" },
-- drain = { "source", "victim", "skill", "amount", "attribute" },
-- durability = { "source", "skill", "victim", "item" }, -- is not item then isAllItems = true
-- enchant = { "source", "victim", "skill", "item" },
-- environment = { "victim", "amount", "damageType" },
-- experience = { "amount", "source", "bonusAmount", "bonusType", "penaltyAmount", "penaltyType", "amountRaidPenalty", "amountGroupBonus", "victim" },
-- extraattack = { "victim", "skill", "amount" },
-- fade = { "victim", "skill" },
-- fail = { "source", "skill", "reason" },
-- feedpet = { "victim", "item" },
-- gain = { "source", "victim", "skill", "amount", "attribute" },
-- heal = { "source", "victim", "skill", "amount", "isCrit", "isDOT" },
-- hit = { "source", "victim", "skill", "amount", "element", "isCrit", "isDOT", "isSplit" },
-- honor = { "amount", "source", "sourceRank" }, -- if amount == false then isDishonor = true.
-- interrupt = { "source", "victim", "skill" },
-- leech = { "source", "victim", "skill", "amount", "attribute", "sourceGained", "amountGained", "attributeGained" },
-- miss = { "source", "victim", "skill", "missType" },
-- reputation = { "faction", "amount", "rank", "isNegative" },


local Parse={}
Relog.Parse=Parse

function Parse.Aura(info)
	if info.isBuff then
		Parse.AddLog("Buff", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.applications)
	else
		Parse.AddLog("Debuff", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.applications)
	end
end

function Parse.Cast(info)
	Parse.AddLog("Cast", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, info.isBegin, info.isPerform)
end

function Parse.Create(info)
	if info.isCreated then
		Parse.AddLog("Item", info.sourceName, info.sourceID, nil, nil, nil, "Create", info.amount, "ItemLink", info.itemLink, "ItemName", info.itemName, "ItemRarity", info.itemRarity, "ItemString", info.itemString)
	else
		Parse.AddLog("Item", info.sourceName, info.sourceID, nil, nil, nil, "Loot", info.amount, "ItemLink", info.itemLink, "ItemName", info.itemName, "ItemRarity", info.itemRarity, "ItemString", info.itemString)
	end
end

function Parse.Damage(info)
	local Result="Hit"
	local Ability=info.abilityName

	if info.isCrit then
		Result="Crit"
	elseif info.isDoT then
		Result="Tick"
	elseif info.isGlancing then
		Result="Glancing"
	elseif info.isCrushing then
		Result="Crushing"
	elseif info.isSplit then
		Result="Split"	
	end

	if not Ability then
		Ability="melee"
	end

	Parse.AddLog("Damage", info.sourceName, info.sourceID, info.recipientName, info.recipientID, Ability, Result, info.amount, "DamageType", info.damageType, "AbsorbAmount", info.absorbAmount, "BlockAmount", info.blockAmount, "ResistAmount", info.resistAmount, "VulnerableAmount", info.vulnerableAmount)
end

function Parse.Death(info)
	local Ability=info.abilityName

	if info.sourceName and Ability==false then
		Ability="melee"
	end

	Parse.AddLog("Death", info.sourceName, info.sourceID, info.recipientName, info.recipientID, Ability, info.isItem)
end

function Parse.Dispel(info)
	Parse.AddLog("Dispel", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.sourceAbilityName, info.isItem, nil, "VictimAbility", info.recipientAbilityName)
end

--[[
Drain Logs
Attribute=Attribute Drained
]]
function Parse.Drain(info)
	Parse.AddLog("Drain", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, info.amount, "Attribute", info.attribute)
end

--[[
Durability
itemLink=Item damaged (need to either add to Parser-3.0 or here rarity etc info)
]]
function Parse.Durability(info)
	Parse.AddLog("Durability", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, nil, "ItemLink", info.item)
end


function Parse.Enchant(info)
	Parse.AddLog("Enchant", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, nil, "ItemLink", info.item)
end

function Parse.Environment(info)
	Parse.AddLog("Environment", nil, nil, info.recipientName, info.recipientID, info.abilityName, info.hazardType, info.amount, "DamageType", info.damageType, "AbsorbAmount", info.absorbAmount, "BlockAmount", info.blockAmount, "ResistAmount", info.resistAmount, "VulnerableAmount", info.vulnerableAmount)
end

function Parse.Experience(info)
	Parse.AddLog("Experience", info.sourceName, info.sourceID, info.recipientName, info.recipientID, nil, nil, info.amount, "BonusAmount", info.bonusAmount, "BonusType", info.bonusType, "PenaltyAmount", info.penaltyAmount, "PenaltyType", info.penaltyType, "AmountRaidPenalty", info.amountRaidPenalty,"AmountGroupBonus",info.amountGroupBonus)
end

function Parse.ExtraAttack(info)
	Parse.AddLog("Extra Attack", nil, nil, info.recipientName, info.recipientID, info.abilityName, nil, info.amount)
end

function Parse.Fade(info)
	Parse.AddLog("Fade", nil, nil, info.recipientName, info.recipientID, info.abilityName)
end

function Parse.Fail(info)
	Parse.AddLog("Fail", info.sourceName, info.sourceID, nil, nil, info.abilityName, info.reason)
end

function Parse.FeedPet(info)
	Parse.AddLog("Feed Pet", nil, nil, info.recipientName, info.recipientID, nil, nil, nil, "ItemLink", info.item)
end

function Parse.Gain(info)
	Parse.AddLog("Gain", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, info.amount, "Attribute", info.attribute)
end

function Parse.Heal(info)
	local Result="Heal"

	if info.isCrit then
		Result="Crit"
	elseif info.isDoT then
		Result="Tick"
	end

	Parse.AddLog("Heal", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, Result, info.amount, "Overheal", info.overhealAmount)
end

function Parse.Honor(info)
	Parse.AddLog("Honor", info.sourceName, info.sourceID, UnitName("player"), "player", nil, nil, info.amount)
end

function Parse.Interrupt(info)
	Parse.AddLog("Interrupt", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName)
end

function Parse.Leech(info)
	Parse.AddLog("Leech", info.sourceName, info.sourceID, info.recipientName, info.recipientID, info.abilityName, nil, info.amount, "Attribute", info.attribute, "SourceGained", info.sourceGainedName, "AttributeGained", info.attributeGained, "AmountGained", info.amountGained)

	--Need to add info gathering on sourceGained
	if info.sourceGainedName and info.sourceGainedName~=info.sourceName and info.sourceGainedName~=info.recipientName then
		Relog.Units:AddUnitLog(info.sourceGainedName)
	end
	if info.sourceGainedID then
		Relog.Units:UpdateUnit(info.sourceGainedID,Relog:GetTime())
	elseif info.sourceGainedName then
		Relog.Units:UpdateUnitByName(Source,Relog.db.char.Log.Time[num])
	end
end

function Parse.Miss(info)
	local Ability=info.abilityName

	if not Ability then
		Ability="melee"
	end

	Parse.AddLog("Miss", info.sourceName, info.sourceID, info.recipientName, info.recipientID, Ability, info.missType)
end

function Parse.Reputation(info)
	Parse.AddLog("Reputation", UnitName("player"), "player", nil, nil, info.abilityName, nil, info.amount, "Rank", info.rank, "Faction", info.faction)
end

function Parse.SetupParser()
	Relog:RegisterParserEvent({eventType = "Aura"}, Parse.Aura)
	Relog:RegisterParserEvent({eventType = "Cast"}, Parse.Cast)
	Relog:RegisterParserEvent({eventType = "Create"}, Parse.Create)
	Relog:RegisterParserEvent({eventType = "Damage"}, Parse.Damage)
	Relog:RegisterParserEvent({eventType = "Death"}, Parse.Death)
	Relog:RegisterParserEvent({eventType = "Dispel"}, Parse.Dispel)
	Relog:RegisterParserEvent({eventType = "Drain"}, Parse.Drain)
	Relog:RegisterParserEvent({eventType = "Durability"}, Parse.Durability)
	Relog:RegisterParserEvent({eventType = "Enchant"}, Parse.Enchant)
	Relog:RegisterParserEvent({eventType = "Environmental"}, Parse.Environment)
	Relog:RegisterParserEvent({eventType = "Experience"}, Parse.Experience)
	Relog:RegisterParserEvent({eventType = "Extra Attack"}, Parse.ExtraAttack)
	Relog:RegisterParserEvent({eventType = "Fade"}, Parse.Fade)
	Relog:RegisterParserEvent({eventType = "Fail"}, Parse.Fail)
	Relog:RegisterParserEvent({eventType = "Feed Pet"}, Parse.FeedPet)
	Relog:RegisterParserEvent({eventType = "Gain"}, Parse.Gain)
	Relog:RegisterParserEvent({eventType = "Heal"}, Parse.Heal)
	Relog:RegisterParserEvent({eventType = "Honor"}, Parse.Honor)
	Relog:RegisterParserEvent({eventType = "Interrupt"}, Parse.Interrupt)
	Relog:RegisterParserEvent({eventType = "Leech"}, Parse.Leech)
	Relog:RegisterParserEvent({eventType = "Miss"}, Parse.Miss)
end


--Still need to add functions and calls for processing the units
local Abbrev={
	Type=true,
	Source=true,
	Victim=true,
	Result=true,
	Ability=true,
	VictimAbility=true,
	DamageType=true,
	Attribute=true,
	ItemName=true,
	ItemString=true,
	BonusType=true,
	PenaltyType=true,
	SourceGained=true,
	AttributeGained=true,
	Faction=true,
	Rank=true,
}

local Reset={}
function Parse.AddLog(Type, Source, SourceUnit, Victim, VictimUnit, Ability, Result, Amount, Extra1, Arg1, Extra2, Arg2, Extra3, Arg3, Extra4, Arg4, Extra5, Arg5, Extra6, Arg6)
	local num=Relog.db.char.NextLog
	local log=Relog.db.char.Log

	for k in pairs(Reset) do
		Reset[k]=false
	end

	--First do we need to remove old unit log info
	if Relog.db.char.LogSize==Relog.db.profile.MaxLogs then
		if log.Source[num] then
			Relog.Units:RemoveUnitLog(log.Source[num])
		end
		if log.Victim[num] and log.Source[num]~=log.Victim[num] then
			Relog.Units:RemoveUnitLog(log.Victim[num])
		end
		if log.SourceGained[num] and log.Source[num]~=log.SourceGained[num] and log.Victim[num]~=log.SourceGained[num] then
			Relog.Units:RemoveUnitLog(log.SourceGained[num])
		end
	end
	
	--Init Log
	

	log.Time[num]=Relog:GetTime()
	Reset.Time=true
	log.Type[num]=Type
	Reset.Type=true
	log.Source[num]=Source
	Reset.Source=true
	log.Victim[num]=Victim
	Reset.Victim=true
	log.Ability[num]=Ability
	Reset.Ability=true
	log.Result[num]=Result
	Reset.Result=true
	log.Amount[num]=Amount
	Reset.Amount=true

	if Extra1 then
		log[Extra1][num]=Arg1
		Reset[Extra1]=true
	end

	if Extra2 then
		log[Extra2][num]=Arg2
		Reset[Extra2]=true
	end

	if Extra3 then
		log[Extra3][num]=Arg3
		Reset[Extra3]=true
	end

	if Extra4 then
		log[Extra4][num]=Arg4
		Reset[Extra4]=true
	end

	if Extra5 then
		log[Extra5][num]=Arg5
		Reset[Extra5]=true
	end

	if Extra6 then
		log[Extra6][num]=Arg6
		Reset[Extra6]=true
	end


	--Abbreviate
	for k in pairs(Abbrev) do
		if log[k][num]~=nil then
			log[k][num]=Relog.Abbrev:GetAbbrev(log[k][num])
		end
	end
	
	--Inc log count for units
	if Source then
		Relog.Units:AddUnitLog(Source)
	end
	if Vicitim and Victim~=Source then
		Relog.Units:AddUnitLog(Victim)
	end

	--Reset those not set
	for k, v in pairs(log) do
		if not Reset[k] then
			v[num]=nil
		end
	end


	Relog.db.char.LogSize=(Relog.db.char.LogSize+1)

	if Relog.db.char.LogSize>Relog.db.profile.MaxLogs then
		Relog.db.char.LogSize=Relog.db.profile.MaxLogs
		Relog.db.char.StartLog=Relog.db.char.StartLog+1
		if Relog.db.char.StartLog>Relog.db.profile.MaxLogs then
			Relog.db.char.StartLog=1
		end
		
		if log[Relog.db.char.StartLog] then
			Relog.Units:DeleteBeforeTime(log[Relog.db.char.StartLog].Time)
		end

		Relog:DecFilter()
	end

	Relog.db.char.NextLog=num+1

	if Relog.db.char.NextLog>Relog.db.profile.MaxLogs then
		Relog.db.char.NextLog=1
	end

	--Update Units
	if SourceUnit then
		Relog.Units:UpdateUnit(SourceUnit,log.Time[num])
	elseif Source then
		Relog.Units:UpdateUnitByName(Source,log.Time[num])
	end

	if VictimUnit then
		Relog.Units:UpdateUnit(VictimUnit,log.Time[num])
	elseif Victim then
		Relog.Units:UpdateUnitByName(Victim,log.Time[num])
	end


	Relog.Tags.CompileLog(num)
	Relog:FilterNewLog()
	Relog.TableWindow.Table:UpdateRows()
end

local LogEntry={}

function Relog:GetLog(num)
	if not num then
		return LogEntry
	end
	num=num+Relog.db.char.StartLog-1
	while num>=Relog.db.char.LogSize do
		num=num-Relog.db.char.LogSize
	end

	for k, v in pairs(Relog.db.char.Log) do
		if v[num] and Abbrev[k] then
			LogEntry[k]=Relog.Abbrev:GetWord(v[num])
		else
			LogEntry[k]=v[num]
		end
	end
	return LogEntry
end

function Relog:GetLogRaw(num)
	if not num then
		return LogEntry
	end

	for k, v in pairs(Relog.db.char.Log) do
		if v[num] and Abbrev[k] then
			LogEntry[k]=Relog.Abbrev:GetWord(v[num])
		else
			LogEntry[k]=v[num]
		end
	end
	return LogEntry
end

local Filtered={}
local FilterTag
function Relog:FilterLog(Tag)
	for k in pairs(Filtered) do
		Filtered[k]=nil
	end

	local Result,Log
	for i=1,Relog.db.char.LogSize do
		Log=Relog:GetLog(i)
		Result=Relog.Tags.CompileTag(Tag,Log)

		if Result~="" then
			table.insert(Filtered,i)
		end
	end
	FilterTag=Tag
end

function Relog:DecFilter()
	for k,v in pairs(Filtered) do
		Filtered[k]=v-1
	end

	if Filtered[1]<=0 then
		table.remove(Filtered,1)
		Relog:DecSort()
	end
end

function Relog:GetFilteredSize()
	return #Filtered
end

function Relog:GetFilter()
	return FilterTag
end

function Relog:GetFilteredLog(num)
	return Relog:GetLog(Filtered[num])
end

function Relog:FilterNewLog()
	local Result,Log
	local num=Relog.db.char.LogSize
	Log=Relog:GetLog(num)
	Result=Relog.Tags.CompileTag(FilterTag,Log)

	if Result~="" then
		local Bottom=Relog.TableWindow.Table:AtBottom()
		table.insert(Filtered,num)

		Relog:SortNewLog(Log,#Filtered)

		if Bottom then
			Relog.TableWindow.Table:SetPosBottom()
		end
	end
end



local Sorted={}
local SortTag
local SortDir=true
local function SortTable(a,b)
	if type(a[1])=="number" then
		if type(b[1])~="number" then
			b[1]=tonumber(b[1])
			if b[1]==nil then
				b[1]=0
			end
		end
	elseif type(b[1])=="number" then
		a[1]=tonumber(a[1])
		if a[1]==nil then
			a[1]=0
		end
	end

	if a[1]<b[1] then
		return true
	elseif a[1]==b[1] then
		if a[2]<b[2] then
			return true
		end
	end
	return false
end

local function SortTableReverse(a,b)
	if type(a[1])=="number" then
		if type(b[1])~="number" then
			b[1]=tonumber(b[1])
			if b[1]==nil then
				b[1]=0
			end
		end
	elseif type(b[1])=="number" then
		a[1]=tonumber(a[1])
		if a[1]==nil then
			a[1]=0
		end
	end

	if a[1]>b[1] then
		return true
	elseif a[1]==b[1] then
		if a[2]<b[2] then
			return true
		end
	end
	return false
end

function Relog:SortLog(sortTag)
	for k,v in pairs(Sorted) do
		Relog:FreeTable(v)
		Sorted[k]=nil
	end

	local Result,Log
	for k,v in pairs(Filtered) do
		Log=Relog:GetLog(v)

		Sorted[#Sorted+1]=Relog:GetTable()
		Sorted[#Sorted][1]=Relog.Tags.CompileTag(sortTag,Log)
		Sorted[#Sorted][2]=k
	end
	
	SortTag=sortTag
	SortDir=true
	table.sort(Sorted,SortTable)
end

function Relog:SortReverse()
	SortDir=false
	table.sort(Sorted,SortTableReverse)
end

function Relog:SortNewLog(log, num)
	if not SortTag then
		return
	end
	Sorted[#Sorted+1]=Relog:GetTable()
	Sorted[#Sorted][1]=Relog.Tags.CompileTag(SortTag,log)
	Sorted[#Sorted][2]=num

	if SortDir then
		table.sort(Sorted,SortTable)
	else
		table.sort(Sorted,SortTableReverse)
	end
end

function Relog:DecSort()
	local NeedRemoving
	for k,v in pairs(Sorted) do
		v[2]=v[2]-1

		if v[2]==0 then
			NeedsRemoving=k
		end
	end

	if NeedsRemoving then
		table.remove(Sorted,NeedsRemoving)
	end
end

function Relog:GetSortedLog(num)
	return Relog:GetFilteredLog(Sorted[num][2])
end

function Relog:ResetFilterAndSort()
	Sorted={}
	Filtered={}
end